//
//  StoryRTEView.swift
//  SampleApp
//
//  Created by Manuchet Rungraksa on 17/1/2567 BE.
//  Copyright © 2567 BE David Zhang. All rights reserved.
//

import Foundation
import SwiftUI
import AmitySDK

struct StoryRTEView: View {
    
    @StateObject var viewModel: StoryRTEViewModel
    
    var body: some View {
        VStack {
            Text(viewModel.displayText)
            Button("Subscribe Story Event") {
//                viewModel.story.subscribeEvent(.story) { success, error in
//                    
//                }
            }
            Button("Unsubscribe Story Event") {
//                viewModel.story.unsubscribeEvent(.story) { success, error in
//                    
//                }
            }
        }
    }
}

class StoryRTEViewModel: ObservableObject {
    
    var token: AmityNotificationToken?
    let storyRepo = AmityStoryRepository(client: AmityManager.shared.client!)
    let story: AmityStory
    
    @Published var displayText: String = ""
        
    init(story: AmityStory, type: AmityReactionReferenceType = .message) {
        self.story = story
        Task {
            self.token = await storyRepo.getStory(storyId: story.storyId).observe({ [weak self] liveObject, error in
                guard let story = liveObject.snapshot else { return }
                let storyModel = StoryModel(story: story)
                self?.displayText = ""
                for data in storyModel.getPreviewData() {
                    self?.displayText += "\(data.key): \(data.value)\n"
                }
            })
        }
    }
    
}
